
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>《Python Cookbook（第2版）中文版》——1.10 过滤字符串中不属于指定集合的字符 / iVAN</title>

    <meta name="description" content="《Python Cookbook（第2版）中文版》——1.10 过滤字符串中不属于指定集合的字符 1.10 过滤字符串中不属于指定集合的字符 任务 给定一个需要保留的字符的集合,构建一个过滤函数,并可将其应用于任何字符串s,函数返回一个s的拷贝,该拷贝只包含指定字符集合中的元素. 解决方案 对于此类问题,string对象的translate方法是又快又好用的工具.不过,为了有效地使用translate来解决问题,事先我们必须做一些准备工作.传递给translate的第一个参数是一个翻译表:在本节中,我们其实不需要什么翻译,所以我们必须准备一个特制的参数来指明&quot;无须翻译&quot;. ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">《Python Cookbook（第2版）中文版》——1.10 过滤字符串中不属于指定集合的字符</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h3>1.10 过滤字符串中不属于指定集合的字符</h3>
<p>任务</p>
<p>给定一个需要保留的字符的集合，构建一个过滤函数，并可将其应用于任何字符串s，函数返回一个s的拷贝，该拷贝只包含指定字符集合中的元素。</p>
<p>解决方案</p>
<p>对于此类问题，string对象的translate方法是又快又好用的工具。不过，为了有效地使用translate来解决问题，事先我们必须做一些准备工作。传递给translate的第一个参数是一个翻译表：在本节中，我们其实不需要什么翻译，所以我们必须准备一个特制的参数来指明“无须翻译”。第二个参数指出了我们需要删除的字符：这个任务要求我们保留（正好反过来，不是删除）属于某字符集合的字符，所以我们必须为该字符集合准备一个补集，作为第二个参数—这样就可以删除所有我们不想保留的字符。闭包是一次性完成所有准备工作的最好方法，它能够返回一个满足需求的快速过滤函数：</p>
<pre><code>import string
# 生成所有字符的可复用的字符串，它还可以作为
# 一个翻译表，指明“无须翻译”
allchars = string.maketrans('', '')
def makefilter(keep):
     """ 返回一个函数，此返回函数接受一个字符串为参数
         并返回字符串的一个部分拷贝，此拷贝只包含在
         keep中的字符，注意keep必须是一个普通字符串
     """
     # 生成一个由所有不在keep中的字符组成的字符串：keep的
     # 补集，即所有我们需要删除的字符
     delchars = allchars.translate(allchars, keep)
     # 生成并返回需要的过滤函数（作为闭包）
     def thefilter(s):
           return s.translate(allchars, delchars)
     return thefilter
if _ _name_ _ == '_ _main_ _':
     just_vowels = makefilter('aeiouy')
     print just_vowels('four score and seven years ago')
# 输出：ouoeaeeyeaao
     print just_vowels('tiger, tiger burning bright')
# 输出：ieieuii
</code></pre>
<p>讨论</p>
<p>理解本节技巧的关键在于对Python标准库的string模块的maketrans函数以及字符串对象的translate方法的理解。translate应用于一个字符串并返回该字符串的一个拷贝，这个拷贝中的所有字符都将按照传入的第一个参数（翻译表）指定的替换方式来替换，而且，第二个参数指定的所有字符都将被删除。maketrans是创建翻译表的一个工具函数。（翻译表是一个正好有256个字符的字符串t：当你把t作为第一个参数传递给translate方法时，原字符串中的每一个字符c，在处理之后都被翻译成了字符t[ord(c)]。）</p>
<p>在本节的技巧中，我们将整个过滤任务分解为准备阶段和执行阶段，使效能达到了最大化。由于包含所有字符的字符串需要重复使用，我们只创建它一次，并在模块导入后将它设置为全局变量。采用这种方式的原因是我们确定每个过滤函数都使用同样的翻译表，因此它非常节省内存。而我们要传递给translate的第二个参数—需要删除的字符，则依赖于需要保留的字符集合，因为它完全是后者的“补集”：我们需要通知translate删除我们不想保留的字符。所以，我们用makefilter工厂函数来创建需要删除的字符集合（字符串），即通过使用translate方法来删除“需要保留的字符”，这一步很快得以完成。和本节的其他函数一样，无论是创建还是执行，translate的速度都非常快。程序中的执行部分给出的测试代码，则展示了如何通过调用makefilter构建一个过滤函数，并给这个过滤函数绑定一个名字（只需简单地给makefilter的返回结果指定个名字即可），然后对一些测试字符串调用该函数并打印出结果。</p>
<p>顺带一提，用allchars作为参数调用过滤函数会把所有需要保留的字符处理成一种非常规整的字符串—严格按照字母表排序而且没有重复的字符。可以根据这种思路编写一个很简单的函数，将以字符串形式给出的字符集合处理成规整的形式：</p>
<pre><code>def canonicform(s):
     """ 给定字符串s，将s的字符以一种规整的字符串形式返回：
         按照字母顺序排列且没有重复 """
     return makefilter(s)(allchars)
</code></pre>
<p>在“解决方案”小节中给出的代码，使用了def语句来建立一个嵌套的函数（闭包），这是因为def是最常见、最通用，也是最清晰的创建函数的语句。不过如果你乐意，也可以用lambda来代替原来的语句，只需修改makefilter函数中的def和return语句，然后写成只需一行的return lambda语句：</p>
<pre><code>return lambda s: s.translate(allchars, delchars)
</code></pre>
<p>大多数Python玩家认为，相对于lambda，def更清晰且更具可读性。</p>
<p>既然本节处理的一些字符串可以被看作字符集合，也可以用sets.Set类型（或Python 2.4中的内建set类型）来完成相同的任务。但得益于translate方法的威力和速度，在类似的这种直接处理字符串的任务中，使用translate总是比通过set来实现要快一些。不过，正如第1.8节提到的，本节中给出的技巧只适用于普通字符串，对Unicode字符串则不适用。</p>
<p>为了能够解决Unicode字符串的问题，我们需要做完全不同的准备工作。Unicode字符串的translate方法只需要一个参数：一个序列或者映射，并且根据字符串中的每个字符的码值进行索引。码值不是映射的键（或者序列的索引值）的字符会被直接复制，不做改变。与每个字符码对应的值必须是一个Unicode字符串（该字符的替换物）或者None（这意味着该字符需要被删除）。这种用法看上去既优雅又强大，可惜对于普通字符串却不适用，所以我们还得重写代码。</p>
<p>通常，我们使用dict或list作为Unicode字符串的translate方法的参数，来翻译或者删除某些字符。但由于本节任务有些特殊（保留一些字符，删掉所有其余字符），我们可能会需要一个非常庞大的dict或string—但仅仅是把所有的其他字符映射到None。更好的办法是，编写一个简单的大致实现了 _getitem _（进行索引操作时会调用的特殊方法）方法的类。一旦我们花点功夫完成了这个小类，我们可以让这个类的实例可被调用，还可以直接给这个类起个makefilter的别名：</p>
<pre><code>import sets
class Keeper(object):
       def _ _init_ _(self, keep):
             self.keep = sets.Set(map(ord, keep))
       def _ _getitem_ _(self, n):
             if n not in self.keep:
                    return None
             return unichr(n)
       def _ _call_ _(self, s):
             return unicode(s).translate(self)
makefilter = Keeper
if _ _name_ _== '_ _main_ _':
       just_vowels = makefilter('aeiouy')
       print just_vowels(u'four score and seven years ago')
# 输出：ouoeaeeyeaao
       print just_vowels(u'tiger, tiger burning bright')
# 输出：ieieuii
</code></pre>
<p>我们也可以直接就把这个类命名为makefilter，但是，基于传统，一个类的名字通常应该首字母大写；遵循传统一般来说没有什么害处，所以，代码就成了这个样子。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-04 11:01:42</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/%e7%b4%a2%e5%bc%95/" title="索引">索引</a>, <a href="https://www.iamivan.net/tag/python/" title="python">python</a>, <a href="https://www.iamivan.net/tag/string/" title="string">string</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>《Python Cookbook（第2版）中文版》——1.10 过滤字符串中不属于指定集合的字符的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/6b3Z07z.html" rel="bookmark">python过滤字符串中不属于指定集合中字符的类实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  本文实例讲述了python过滤字符串中不属于指定集合中字符的类.分享给大家供大家参考.具体如下: ? 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 # -*- coding: utf-8 -*- import sets class Keeper(object): def __init__(self, keep): self.keep = sets.Set(map(ord, keep)) def __getitem__(self, n): if n			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9Xrv3b.html" rel="bookmark">《像计算机科学家一样思考Python（第2版）》&mdash;&mdash;2&period;6 字符串操作</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.6 字符串操作 通常来说,字符串不能进行数学操作.即使看起来像数字也不行.下面的操作是非法的: '2' - '1' 'eggs'/'easy' 'third'*'a charm' 但有两个例外:+和*. 操作符+进行字符串拼接(string concatenation)操作,意即将前后两个字符首尾连接起来.例如: &gt;&gt;&gt; first = 'throat' &gt;&gt;&gt; second = 'warbler' &gt;&gt;&gt; first + second throa			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mqank3M.html" rel="bookmark">《Python Cookbook（第2版）中文版》&mdash;&mdash;导读</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前 言 这本书不是一本典型的O'Reilly风格的书,而是一本集合了多个作者的手稿的作品.实际上,这也是一种将开源开发的方式应用到书籍出版业的尝试.Python社区有超过300个成员在本书中贡献了他们的心得和资料.在这里,我们作为编辑,想给你--本书的读者,介绍一些重要的背景资料,这些背景资料是关于此书是如何编著出来,以及这个过程和涉及的人,并提出一些关于这种崭新的风格的思考. 目 录 [第1章 文本1.1 每次处理一个字符](https://yq.aliyun.com/articles/963			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVQkB4p.html" rel="bookmark">《Python Cookbook（第2版）中文版》&mdash;&mdash;1&period;9 简化字符串的translate方法的使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.9 简化字符串的translate方法的使用 任务 用字符串的translate方法来进行快速编码,但却发现很难记住这个方法和string.maketrans函数的应用细节,所以需要对它们做个简单的封装,以简化其使用流程. 解决方案 字符串的translate方法非常强大而灵活,具体细节可参考第1.10节.正因为它的威力和灵活性,将它&quot;包装&quot;起来以简化应用就成了个好主意.一个返回闭包的工厂函数可以很好地完成这种任务: import string def translator(frm			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MNnm1JM.html" rel="bookmark">《Python Cookbook（第3版）中文版》&mdash;&mdash;6&period;10　Base64编码和解码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				6.10 Base64编码和解码 6.10.1 问题 我们需要采用Base64编码来对二进制数据做编码解码操作. 6.10.2 解决方案 base64模块中有两个函数--b64encode()和b64decode()--它们正是我们所需要的.示例如下: &gt;&gt;&gt; # Some byte data &gt;&gt;&gt; s = b'hello' &gt;&gt;&gt; import base64 &gt;&gt;&gt; # Encode as Base64 &gt;&gt;&gt;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7ZeKAp.html" rel="bookmark">《Python Cookbook（第2版）中文版》&mdash;&mdash;1&period;15 扩展和压缩制表符</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.15 扩展和压缩制表符 任务 将字符串中的制表符转化成一定数目的空格,或者反其道而行之. 解决方案 将制表符转换为一定数目的空格是一种很常见的需求,用Python的字符串提供的expandtabs方法可以轻松解决问题.由于字符串不能被改变,这个方法返回的是一个新的字符串对象,是原字符串的一个修改过的拷贝.不过,仍可以将修改过的拷贝绑定到原字符串的名字: mystring = mystring.expandtabs( ) 这样并不会改变mystring原先指向的字符串对象,只不过将名字myst			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2RgqBb.html" rel="bookmark">《Python Cookbook（第2版）中文版》&mdash;&mdash;1&period;8 检查字符串中是否包含某字符集合中的字符</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.8 检查字符串中是否包含某字符集合中的字符 任务 检查字符串中是否出现了某字符集合中的字符. 解决方案 最简单的方法如下,兼具清晰.快速.通用(适用于任何序列,不仅仅是字符串,也适用于任何容器,不仅仅是集合): def containsAny(seq, aset): &quot;&quot;&quot; 检查序列seq是否含有aset中的项 &quot;&quot;&quot; for c in seq: if c in aset: return True return False 也可以使用更高级和			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdvq2Xb.html" rel="bookmark">《Python Cookbook（第3版）中文版》&mdash;&mdash;第6章 数据编码与处理   6&period;1 读写CSV数据</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第6章 数据编码与处理 本章主要关注的重点是利用Python来处理以各种常见编码形式所呈现出的数据,比如CSV文件.JSON.XML以及二进制形式的打包记录.与数据结构那章不同,本章不会把重点放在特定的算法之上,而是着重处理数据在程序中的输入和输出问题上. 6.1 读写CSV数据 6.1.1 问题 我们想要读写CSV文件中的数据. 6.1.2 解决方案 对于大部分类型的CSV数据,我们都可以用csv库来处理.比如,假设在名为stocks.csv的文件中包含有如下的股票市场数据: Symbol,P			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLd4Rap.html" rel="bookmark">《Python Cookbook（第2版）中文版》&mdash;&mdash;第1章 文本  1&period;1 每次处理一个字符</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第1章 文本 引言 感谢:Fred L. Drake, Jr.,PythonLabs 对于脚本语言来说,文本处理任务构成了一个重要的组成部分,每个人都会同意文本处理非常有用.每个人都会有一些文本需要重新格式化或者转化为另一种形式.问题是,每个程序都与另一个程序有点不同,无论它们是多么相似,想提取出一些可复用的代码片段并用它来处理不同的文件格式仍然是非常困难的. 什么是文本 看起来问题有点简单得过分了,事实上,我们看到了文本,就知道了什么是文本,文本是一串字符,这正是它与二进制数据之间的不同.二进			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMr3ejp.html" rel="bookmark" class="title">WPS如何显示花样线条</a>
					<div>
						  办公文档中,有时我们会在段落间添加必要的分隔线.分隔线的花样繁多,利用直线绘制工具辅以各种线型设置,可以设计出花样分隔线.但问题是线条与文字往往会存在因版面重排而错乱的情况,且画出这样的线条也比较 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/rz4WmJp.html" rel="bookmark" class="title">Photoshop制作精致的紫色水晶心形</a>
					<div>
						作者制作心形的时候非常细致,加入了很多细节,如中间的网状光束,星光,边缘线条,光斑背景等,虽然制作繁琐一点,不过效果非常细腻. 最终效果 1.新建大小自定画布,新建一个图层,建立一条路径,调整到你想象 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qbaNOmM.html" rel="bookmark" class="title">制作网页时关于网页浏览器兼容问题的分析</a>
					<div>
						浏览器|网页|问题 IE vs FFCSS 兼容要点: DOCTYPE 影响 CSS 处理 FF: div 设置 margin-left, margin-right 为 auto 时已经居中, IE  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8jJDBb.html" rel="bookmark" class="title">学Linq to sql（三）：增、删、改</a>
					<div>
						示例数据库 字段名 字段类型 允许空 字段说明 ID uniqueidentifier   表主键字段 UserName varchar(50)   留言用户名 PostTime datetime   ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bElyGLz.html" rel="bookmark" class="title">高效的Java异常处理</a>
					<div>
						Java开发人员可以做出的最重要的架构性决策之一就是如何使用Java异常模型.Java异常一直以来就是社群中许多争议的靶子.有人争论到,在Java语言中的异常检查已是一场失败的试验.本文将辨析,失败的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY27Wrp.html" rel="bookmark" class="title">用PS制作特效字教程</a>
					<div>
						用PS制作特效字教程 最终效果图 1.运行Photoshop,新建一个600x400像素.72dpi的RGB图像.如图1所示. 图1 2.执行滤镜/渲染/云彩,将背景图层制作成云彩的效果.如图2所示. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGjOxop.html" rel="bookmark" class="title">getElementsByTagName的简写方式</a>
					<div>
						用最少的代码,做最多的事情. getElementsByTagName的简写方法 //CLASS@Mr.Think*****getElementsByTagNamefunction tag(name, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5APnBp.html" rel="bookmark" class="title">ppt幻灯片怎么转换成swf格式文件</a>
					<div>
						  SWF 格式的最大特点是体积小巧.易于分发,兼容所有的操作系统和浏览器,把PowerPoint转换为Flash有如下两个明显的好处:压缩演示文稿的体积,减少空间占用;更好的兼容性,可以让演示在任何 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvK0Vrp.html" rel="bookmark" class="title">WPS表格中控件工具箱的用处</a>
					<div>
						  上面经过对WPS文字以及演示的学习后,相信大家都了解了常用控件工具在PPT中插入Flash动画.而现在小编要为大家介绍的是在WPS表格中通过控件工具来插入Flash动画的方法,具体来看下操作步骤. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK7D5nb.html" rel="bookmark" class="title">win7系统默认字体怎么修改</a>
					<div>
						  具体设置步骤: 1.在桌面上单击右键,选择[个性化]; 2.点击底部的[窗口颜色]; 3.在项目下拉菜单中选择&quot;已选定的项目&quot;; 4.在字体下拉菜单中选择需要设置的字体,还可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj7AlmM.html" rel="bookmark" class="title">电脑时间不能同步，电脑时间同步出错的解决办法</a>
					<div>
						电脑时间不能同步.电脑时间同步出错的解决步骤: (小窍门:将日期和时间调整为接近当前,将可以避免电脑时间不能同步或进行同步时出错的问题) (在开始下面的设置之前,小编建议将&quot;自动与Inter ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3W7EM.html" rel="bookmark" class="title">Word2010删除全部批注</a>
					<div>
						  一.删除某个批注 如下图一样,找到某个批注,右键点击,在弹出的菜单中选择&quot;删除批注&quot;即可完成操作. 二.删除全部批注 如果文档中使用了批注,那么,就一定会自动显示出名为&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBKdrKM.html" rel="bookmark" class="title">Win7下打印服务器安装设置图文教程</a>
					<div>
						本文将教大家在win7下怎样安装打印服务器. 如果您之前从未使用过打印机,现在想要通过打印服务器来实现共享打印机,您需要按照以下的步骤来添加一个打印机端口并安装打印机的驱动. 1.选择开始 --控制面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr31kOp.html" rel="bookmark" class="title">win7一键备份系统步骤</a>
					<div>
						  Win7无疑是目前最流行的操作系统,但是不适应该系统的朋友往往在使用中导致系统奔溃以及各种毛病,从而反复的重装系统.如果一有问题就重装,会对硬盘造成一定的损坏,那么小编告诉大家win7怎么一键备份 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN16L7b.html" rel="bookmark" class="title">怎样合并长篇txt文档</a>
					<div>
						  先把所有要合并的文件都放到同一个文件夹下,如下图1所示的演示文件. 为了方便大家对比理解,本文用简短内容的txt文档演示,只用3个文件进行合并演示,同时按序号命名各个演示文件,内容也以数字标识.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3o4aJb.html" rel="bookmark" class="title">引入JQuery提示&colon;Uncaught ReferenceError&colon; &dollar; is not defined</a>
					<div>
						在使用jQuery的时候,发现有如下报错: Uncaught ReferenceError: $ is not defined  (anonymous function) 出现这个报错的原因: 1.j ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9EOBkM.html" rel="bookmark" class="title">asp调用Word打印的代码&lowbar;应用技巧</a>
					<div>
						调用Word打印...  运行下列的脚本需要将IE的安全级别设为低,或在中级安全级别下将那个ActiveX控件设为启用,别忘记了:  &lt;html&gt;  &lt;head&gt;  &lt;t ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3Xwlz.html" rel="bookmark" class="title">ios-如果实现点击后增大标签和单元的尺寸</a>
					<div>
						问题描述 如果实现点击后增大标签和单元的尺寸 功能要求实现点击单元的seeMoreBtn 之后,单元尺寸会变大.标签和单元的长度不同,但是他们在同一个label中.如果尺寸过大,我就增加了一个see  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrWPd1p.html" rel="bookmark" class="title">精通css（4）-盒模型，定位，浮动</a>
					<div>
						终于到了css最重要的3个部分:盒模型,定位,浮动.先讲盒模型吧. 1.盒模型概述 页面上的每个元素都被看成一个矩形框.这个框由元素的内容.内边距.边框和外边距组成. 内边距.边框和外边距都是可选的默 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ZE9Az.html" rel="bookmark" class="title">Java -- 容器使用 Set&comma; List&comma; Map&comma; Queue</a>
					<div>
						1. ArrayList ArrayList&lt;String&gt; c = new ArrayList&lt;String&gt;(); c.add(&quot;hello&quot;); c. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB1JeOz.html" rel="bookmark" class="title">zxing 识别本地图片部分二维码无法解析</a>
					<div>
						问题描述 zxing 识别本地图片部分二维码无法解析 android 用zxing直接识别本地图片中的二维码的时候,部分二维码需要图片非常大才能识别,正常大小完全识别不出来,请问有人碰到过吗,有解决方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAEAD2M.html" rel="bookmark" class="title">git简单问题，虚心请教</a>
					<div>
						问题描述 git简单问题,虚心请教 Administrator@PAYBAY-PC /d/java (master) $ git commit -m &quot;Your commit message ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bodLevM.html" rel="bookmark" class="title">十大最酷云计算应用程序创业企业</a>
					<div>
						软件即服务,这种最初的云计算服务交付模式已经被越来越多的企业所认可,帮助企业获得前所未有的可访问性.责任划分以及易于部署的首选方式. 过去的十年间,SaaS的市场版图已经变得拥挤异常,各种顶尖的软件开 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlLvwnM.html" rel="bookmark" class="title">tomcat-启动一个WEB项目出错，但是就是找不到原因</a>
					<div>
						问题描述 启动一个WEB项目出错,但是就是找不到原因 严重: StandardWrapper.Throwable java.lang.NoClassDefFoundError: Lcom/zlh/co ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M606dNz.html" rel="bookmark" class="title">openstack  虚机无法获取IP</a>
					<div>
						问题描述 我用的是icehouse版本,虚机无法获取IP虚机启动日志:[color=#FF0000]解决方案二: 解决方案三: 解决方案四: 解决方案五:debugstart解决方案六: 解决方案七: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK5BDZp.html" rel="bookmark" class="title">vc&plus;&plus;-canny算子C&plus;&plus;实现的代码怎么编写？</a>
					<div>
						问题描述 canny算子C++实现的代码怎么编写? 如题,(重点想知道图片像素点坐标怎么获取)希望能讲的详细一点儿,谢谢. 解决方案 可以参考我的博客,opencv 的实现:http://blog.c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3ZY9Nz.html" rel="bookmark" class="title">iOS应用开发中UIView添加边框颜色及设置圆角边框的方法&lowbar;IOS</a>
					<div>
						UIView加边框及边框颜色 引用库: 复制代码 代码如下: #import &lt;QuartzCore/QuartzCore.h&gt; 使用: 复制代码 代码如下: //添加边框和提示      ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYN1jVp.html" rel="bookmark" class="title">eclipse-IDE运行时，报错的问题</a>
					<div>
						问题描述 IDE运行时,报错的问题 class Point{ private double x; private double y; Point(double _x,double _y){ x = _ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDkg90p.html" rel="bookmark" class="title">有没有人能帮忙改写一段JAVA代码为PHP</a>
					<div>
						问题描述 importjava.util.Random;publicclassPPTVUtil{publicstaticinta(byteabyte0[],inti){intj=0;intk=0;fo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxER27p.html" rel="bookmark" class="title">C&num; MapX自动滚屏，如何能做到平滑？</a>
					<div>
						问题描述 如题,用VS2008环境下,用C#语言开发MapX模块,目前要做自动滚屏,如何能使滚屏的效果做到平滑,因为目前地图移动时上面的图元总是在闪烁.请问高手这个问题如何能解决,给点思路吧,谢谢!  ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
